<template>
  <div id="app">
    <div class="bg-primary">
      <the-announcement-bar />
    </div>
    <div class="bg-primary d-flex justify-content-center flex-shrink-0">
      <div
        id="header"
        class="full-width-container flex-grow-1 d-flex justify-content-between align-items-center"
      >
        <div
          class="flex-grow-1"
          container
        >
          <b-link :to="{ name: 'home' }">
            <img
              id="antares-logo"
              src="./assets/antares-logo.svg"
            >
          </b-link>
        </div>
        <div class="d-flex flex-grow-1 justify-content-end align-items-center">
          <the-searchbar
            class="flex-grow-1 mr-4"
            style="max-width: 300px"
            @search="search"
          />
          <b-link href="https://www.nsf.gov">
            <img
              id="nsf-logo"
              src="./assets/noirlab-nsf-logo-dark.svg"
            >
          </b-link>
        </div>
      </div>
    </div>
    <div class="bg-dark d-flex justify-content-center flex-shrink-0">
      <div class="full-width-container flex-grow-1">
        <the-navbar id="navbar" />
      </div>
    </div>
    <div class="d-flex flex-grow-1 flex-shrink-0 justify-content-center overflow-auto">
      <router-view ref="routerView" />
    </div>
    <div class="d-flex bg-dark justify-content-center flex-shrink-0">
      <div class="full-width-container flex-grow-1 footer bg-dark">
        <b-link href="https://www.aura-astronomy.org/">
          <img
            id="aura-logo"
            src="./assets/aura.png"
          >
        </b-link>
        <b-link href="https://www.hsfoundation.org/">
          <img
            id="hsf-logo"
            src="./assets/HSF_logo.svg"
          >
        </b-link>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';

import { FETCH_ANNOUNCEMENTS } from '@/store/actions';
import { ElasticsearchFilter } from '@/common/types';
import TheAnnouncementBar from '@/components/TheAnnouncementBar.vue';
import TheNavbar from '@/components/TheNavbar.vue';
import TheSearchbar from '@/components/TheSearchbar.vue';

export default Vue.extend({
  components: {
    TheAnnouncementBar,
    TheNavbar,
    TheSearchbar,
  },

  methods: {
    fetchAnnouncements() {
      this.$store.dispatch(FETCH_ANNOUNCEMENTS);
    },
    search(filters: ElasticsearchFilter[]) {
      // This is kind of disgusting but idk what else to do. When a user enters a query
      // into the search bar, the expected behavior is that they are directed to the
      // search (locusList) route with the appropriate query prefilled into the URL.
      //
      // This is as simple as a $router.push from most pages, but what to do if the user
      // is already on the locusList page? There's likely a better way of handling this
      // but my first pass was complicated by the way that we handle query persistence.
      // If a user refines their search on the locusList page, the new query parameters
      // get stored in the URL. That way they can navigate to a different page and then
      // back to their search query (same filters, pagination, etc.).
      //
      // I tried to solve this by adding a watcher to $route on the LocusList view. The
      // problem is that to implement persistence we replace the current URL with a new
      // one everytime we fetch from the API on that view. This would trigger a change
      // to the URL (unclear why, it should stay the same), and the watcher would again
      // call the fetch method.
      if ((<any> this.$router).currentRoute.name === 'locusList') {
        (<any> this.$refs.routerView).resetQuery();
        (<any> this.$refs.routerView).applyFilters(filters);
      } else {
        this.$router.push({
          name: 'locusList',
          query: {
            query: JSON.stringify({ filters }),
          },
        });
      }
    },
  },
});
</script>

<style lang="scss">
@import 'styles/custom.scss';

#hsf-logo {
  max-height: 40px;
  margin: 0 20px;
}

#aura-logo {
  max-height: 40px;
  margin: 0 20px;
}

#navbar {
  flex: none;
}

html,
body {
  height: 100%;
  min-width: 800px;
}

body {
  display: flex;
  flex-direction: column;
}

.content {
  flex: 1 0 auto;
}

#header {
  margin: 15px;
}

.footer {
  flex-shrink: 0;
  padding-top: 15px;
  padding-bottom: 15px;
}

h1,
h2,
h3,
h4,
h5,
h6 {
  font-family: Raleway, sans-serif;
}

.page-item.active .page-link {
  background-color: $dark;
  border-color: $dark;
}

.navbar {
  font-family: Raleway, sans-serif;
  font-weight: bold;
}

.text-box {
  max-width: 700px;
}

.container {
  max-width: 700px;
  margin-top: 20px;
}

.large-container {
  max-width: 1200px;
}

.full-width-container {
  max-width: 100%;
  margin-top: 0px;
}

.tooltip-wide .tooltip-inner {
  max-width: 250px;
}

.tooltip-text-left .tooltip-inner {
  text-align: left;
}

p {
  // font-family: 'PT Serif', serif;
}

#app {
  font-family: 'Raleway', sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  color: #2c3e50;
  height: 100%;
  display: flex;
  flex-direction: column;
}

thead {
  background-color: #edecec;
}

.table-striped > tbody > tr:nth-child(2n + 1) > td,
.table-striped > tbody > tr:nth-child(2n + 1) > th {
  background-color: $light;
}

.table-striped > tbody > tr:nth-child(2n) > td,
.table-striped > tbody > tr:nth-child(2n) > th {
  background-color: #edecec;
}

#nav {
  padding: 30px;

  a {
    font-weight: bold;
    color: #2c3e50;

    &.router-link-exact-active {
      color: #42b983;
    }
  }
}
#antares-logo {
  max-height: 40px;
  margin-left: 5px;
}
#nsf-logo {
  max-width: 140px;
  margin-right: 5px;
}
</style>
